#version 430



vec4 rotateXZ(vec4 p, float a) {
  vec4 r = p;
  r.x = cos(a)*p.x - sin(a)*p.z;
  r.z = sin(a)*p.x + cos(a)*p.z;
  return r;
}

vec3 rotateXZ3(vec3 p, float a) {
  return rotateXZ(vec4(p, 0.0), a).xyz;
}

vec4 rotateXY(vec4 p, float a) {
  vec4 r = p;
  r.x = cos(a)*p.x - sin(a)*p.y;
  r.y = sin(a)*p.x + cos(a)*p.y;
  return r;
}

vec4 rotateYZ(vec4 p, float a) {
  vec4 r = p;
  r.y = cos(a)*p.y - sin(a)*p.z;
  r.z = sin(a)*p.y + cos(a)*p.z;
  return r;
}

layout(triangles) in;
layout(triangle_strip, max_vertices = 15) out;

in vec3 normal[3];
in vec2 uv[3];
in vec3 tangent[3];
in vec4 origPos[3];

out vec4 posG;
out vec3 normalG;
out vec2 uvG;
out vec3 colorG;
out vec3 tangentG;
 
uniform mat4 projectionMatrix;
uniform mat4 modelViewMatrix;

uniform float g_time;

void main(void) {

	float times = g_time*0.1;
    vec3 faceNormal = vec3(0.0);
	vec4 facePos = vec4(0.0);
	for (int i = 0; i < gl_in.length(); ++i) {
		gl_Position = gl_in[i].gl_Position; // -vec4(1.5, 0.0, 0.0, 0.0);
		facePos += origPos[i];
		gl_Position.xyz -= normal[i]*1.5;
		gl_Position = projectionMatrix * modelViewMatrix * gl_Position;
		normalG = normal[i];
		colorG = vec3(0.10, 0.2, 0.25);
		normalG = (modelViewMatrix * vec4(normalG, 0.0)).xyz;
		posG = gl_Position;
		faceNormal += normal[i];
		uvG = uv[i];
		tangentG = tangent[i];
//		EmitVertex();
	}
	facePos /= 3.0;

	EndPrimitive();
	
	vec4 inp = facePos;
	// vec4 inp = ;
	float lim = -10.0;
	float why = 30.0*pow((clamp(sin((inp.y*0.1350-fract(inp.y*0.1350))+times*0.4)*1.0, lim, 1.0)-lim)/(1.0-lim),5.0);
	for (int i = 0; i < gl_in.length(); ++i) {
		vec4 inp = gl_in[i].gl_Position;
    //	why = 1.50*pow((clamp(sin((inp.y*0.10)+g_time*0.4)*1.0, lim, 1.0)-lim)/(1.0-lim),5.0);
		// float lim = 0.75;
		// float why = 8.0*pow((clamp(sin(inp.y*0.1+g_time)*1.0, lim, 1.0)-lim)/(1.0-lim),1.0);
		gl_Position = gl_in[i].gl_Position+vec4(faceNormal*10.0*why, 0.0);
	//	gl_Position = gl_in[i].gl_Position+vec4(normal[i]*10.0*why, 0.0);
		gl_Position.xz += (faceNormal.xz*why*30.0);
	//	gl_Position.xyz += (normal[i].xyz*why*12.0);
    //	gl_Position.xz += (normal[i].xz*why*32.0);
		gl_Position = gl_Position*(1.0-why)+1.0*origPos[i]*why;
		gl_Position = projectionMatrix * modelViewMatrix * gl_Position;
		normalG = normal[i];
		colorG = vec3(1.40, 0.60, 0.20)*(1.0-why*0.0)+vec3(1.1,1.81,0.31)*why*0.0;
		normalG = (modelViewMatrix * vec4(normalG, 0.0)).xyz;
		uvG = uv[i];
		tangentG = tangent[i];
		posG = gl_Position;
		EmitVertex();
	}
	EndPrimitive();
	

	for (int i = 0; i < 3; ++i) {
		gl_Position = gl_in[i].gl_Position;
		if (i==2) {
		  gl_Position += vec4(faceNormal, 0.0)*0.0*why;
		}
	    gl_Position.xyz -= normal[i].xyz*2.0;
		gl_Position = projectionMatrix * modelViewMatrix * gl_Position;
		normalG = normal[i];
		colorG = vec3(1.50, 1.50, 1.50)*(0.0-why*0.0)+vec3(3.1,0.81,0.31);
		normalG = (modelViewMatrix * vec4(normalG, 0.0)).xyz;
		uvG = uv[i];
		tangentG = tangent[i];
		posG = gl_Position;
		EmitVertex();
	}
	EndPrimitive();


	float makkara = 0.15;


	for (int i = 0; i < 3; ++i) {

                gl_Position = gl_in[0].gl_Position;
                if (i==1) {
                  gl_Position += vec4(0.02, 0.020, 0.0, 0.0);
                }
                if (i==2) {
                  gl_Position += vec4(faceNormal, 0.0)*1.50*why*makkara;
                }
            gl_Position.xyz -= normal[i].xyz*2.0;

//            gl_Position = gl_in[i].gl_Position;
////            //gl_Position.xyz -= normal[i].xyz*12.0*why;
//          //  gl_Position += rotateXZ(origPos[i], why*5.0);
//            gl_Position.xyz -= faceNormal*1.0*why;

		gl_Position = projectionMatrix * modelViewMatrix * gl_Position;
		normalG = normal[i];
                colorG = mix(vec3(0.150, 0.150, 0.50),vec3(1.5,0.91,0.91), why*0.2)*0.30;
		normalG = (modelViewMatrix * vec4(normalG, 0.0)).xyz;
		uvG = uv[i];
		tangentG = tangent[i];
		posG = gl_Position;
      //          EmitVertex();
	}
	EndPrimitive();

	
}
