import QtQuick 2.3

import "../" // to import RocketScene

import AdaptDemoSystem 1.0



RocketScene {
    sceneName: "SkeneGlassy"

    anchors.fill: parent

    Image {
        visible: bSceneEnabled
         anchors.fill: parent
      //  width: windowWidth
      //  height: windowHeight
        source: "../../images/adapt_logo2_full.png"
    }

    Blit {
        textureRT: "adaptBG"
    }



    Camera {
        property string name: "camera"
        x: sync(name + ".x")
        y: sync(name + ".y")
        z: sync(name + ".z")
        lookAtX: sync(name + ".lookAtX")
        lookAtY: sync(name + ".lookAtY")
        lookAtZ: sync(name + ".lookAtZ")
        upX: 0.0
        upY: 1.0
        upZ: 0.0
    }

    Shader {
        file: sceneDir+"plastic"
    }
    Texture {
        textureUnit: 0
        textureItem: kuva1
            Image {
                visible: false
                // width: windowWidth
                //height: windowHeight
                // fillMode: Image.PreserveAspectFit
                id: kuva1
                source: "../../images/kivitex1s.png"
               // source: "../../images/adapt_koho_2048.png"
               // source: "../../images/adapt_logo2_full"
            }
    }
    DrawMesh {
        Clear {
            cR: 0.0; cG: 0.00; cB: 0.00
        }

        property string name: "PillarMan"
        //file: "mesh/pillarman.dae"
        file: "mesh/pillarman.obj"
        Pos { x: 0.0; y: -12.0; z: 20.0 }
        Rot { d: -235.0; ax: 0.0; ay: 1.0; az: 0.0; }
        Sca { s: 6.0 }
        // file: "mesh/pillarmanb.x"
      //  file: "mesh/aivob.x"
    }


    Blit {
        textureRT: "glassBg"
    }

    Shader {
        file: sceneDir+"sm"
    }
    Texture {
        textureUnit: 0
        textureItem: kuva
            Image {
                visible: false
                // width: windowWidth
                //height: windowHeight
                // fillMode: Image.PreserveAspectFit
                id: kuva
                source: "../../images/kivitex1s.png"
               // source: "../../images/adapt_koho_2048.png"
               // source: "../../images/adapt_logo2_full.png"
            }
    }


    Texture {
        textureRT: "glassBg"
        textureUnit: 2
    }

    DrawMesh {
//        Clear {
//            cR: 1.0; cG: 1.00; cB: 1.00
//        }

        property string name: "PillarMan"
        //file: "mesh/pillarman.dae"
        Rot { d: -235.0; ax: 0.0; ay: 1.0; az: 0.0; }

        Sca { s: 3.0 }
        //file: "mesh/pillarman.obj"
        file: "mesh/kolkkus_inf.x"
      //  file: "mesh/apehead.obj"

        // file: "mesh/pillarmanb.x"
       // file: "mesh/aivob.x"
       // file: "mesh/cube5000.x"

//        file: "mesh/pillarman.obj"

    }

    Blit {
        textureRT: "blitti"
    }

//    RenderTarget {
//        RenderTargetLayer {
//            textureRT: "blitti"
//        }
//    }
//    Texture {
//        textureRT: "blitti"
//        blit: true
//    }

    Texture {
        textureRT: "blitti"
        textureUnit: 0
    }
    Texture {
        textureRT: "adaptBG"
        textureUnit: 1
    }

    Texture {
        textureRT: "prevScreen"
        textureUnit: 2
    }


    Shader {
        file: sceneDir+"blit"
        ShaderParam {
            paramName: "feedback"
            paramValue: sync("feedback")
        }
    }
    DrawVB {
        type: "quad"
    }



    Blit {
        textureRT: "prevScreen"
    }
}
